routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

// Get controllers
Route::get('/', 'ProjectController@index');
Route::get('/project/{project}/sprints/dashboard', 'SprintController@index')->name('sprint.dashboard');
Route::get('/project/{project}/sprints/{sprint}', 'SprintController@show')->name('sprints.show');
Route::get('/project/{project}/sprints/{sprint}/retrospective', 'RetrospectiveController@index')->name('retrospectives.index');
Route::get('/project/{project}/dashboard', 'ProjectController@show')->name('project.dashboard');
Route::get('/project/{project}/members', 'ProjectTeamController@show')->name('project.team');
Route::get('/project/{project}/backlog', 'BacklogItemController@show')->name('project.backlog');
Route::post('/project/{project}/members', 'ProjectTeamController@store')->name('member.store');
Route::get('/profile/{profile}', 'UserController@show')->name('profile.show');

// Resource controllers
Route::resources(
    [
        'project' => 'ProjectController',
        'members' => "ProjectTeamController",
        'backlogItem' => 'backlogItemController',
        'profile' => 'UserController',
        'sprint' => 'SprintController',
        'admin' => 'AdminController',
        'retrospective' => 'RetrospectiveController'
    ]
);

app/Project.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Project extends Model
{

    public function backlogItems()
    {
        return $this->hasMany(BacklogItem::class);
    }

    public function sprints()
    {
        return $this->hasMany(Sprint::class);
    }

    public function roles()
    {
        return $this->belongsToMany(Role::class)->withPivot('project_id', 'user_id', 'role_id');
    }

    public function users()
    {
        return $this->belongsToMany(User::class)->withPivot('project_id', 'user_id', 'role_id');
    }



    protected $fillable = [
        'id', 'title', 'description', 'deadline'
    ];
}

app/Http/Controllers/ProjectController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\CreateProjectRequest;
use App\Project;
use Illuminate\Http\Request;
use Illuminate\Support\Carbon;
use App\BacklogItem;
use App\User;
use Illuminate\Support\Facades\Auth;

class ProjectController extends Controller
{
    public function __construct()
    {

        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $user_id = Auth::id();
        $profile = Auth::id();
        $projects = User::find($user_id);

        foreach ($projects->projects as $project) {
            $diff = 0;
            $date = Carbon::parse($project->deadline);
            $now = Carbon::now();
            $diff = $date->diffInDays($now);
            $project->deadlineForHumans = $diff;
            $project_new_id = $project->pivot->project_id;
            $project_id = $project->id;

            if ($project_new_id == $project_id) {
                $allProjects = Project::find($project->id);
                $project->userProjects = $userProjects = $allProjects->users()->get();
            }
        }
        return view('projects.index', compact('projects', 'profile'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(CreateProjectRequest $request)
    {
        $data = $request->validated();
        $project = new Project();
        $project->title = $data['title'];
        $project->deadline = $data['deadline'];
        $project->description = $data['description'];

        $project->save();

        $project->users()->attach(Auth::id(), [
            'role_id' => 1
        ]);

        return redirect()->back()->with('date', 'Project is aangemaakt!');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Project $project
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $project = Project::find($id);
        $currentUserProjects = Project::where('id', $id)->get();
        foreach ($currentUserProjects as $currentUserProject) {
            $date = Carbon::parse($currentUserProject->deadline);
            $now = Carbon::now();
            $diff = $date->diffInDays($now);
            $currentUserProject->deadlineForHumans = $diff;
        }
        $backlogItems = BacklogItem::all()->where('project_id', $id);
        $backlogItemTypeFeature = BacklogItem::all()->where('project_id', $id)->where('type', 'Feature');
        $backlogItemTypeBug = BacklogItem::all()->where('project_id', $id)->where('type', 'Bug');
        $backlogItemTypeEpic = BacklogItem::all()->where('project_id', $id)->where('type', 'Epic');

        $usersProjects = $project->users()->wherePivot('project_id', '=', $id)->get();

        $user_id = Auth::id();
        $profile = Auth::id();
        $projects = User::find($user_id);

        // Check if Project exists
        $projectExists = Project::where('id', $id)->exists();

        // show 404 not found page
        abort_unless($projectExists, 404);

        // Get user_id from pivot table
        $userProjectsCheck = $project->users()->wherePivot('user_id', '=', $user_id)->get();

        foreach ($projects->projects as $project) {
            $date = Carbon::parse($project->deadline);
            $now = Carbon::now();
            $diff = $date->diffInDays($now);
            $project->deadlineForHumans = $diff;
            $project_new_id = $project->pivot->project_id;
            $project_id = $project->id;

            if ($project_new_id == $project_id) {
                $allProjects = Project::find($project->id);
                $project->userProjects = $userProjects = $allProjects->users()->get();
            }
            // loop and check if authenticated user owns the project
            foreach ($userProjectsCheck as $userproject) {
                if ($user_id === $userproject->id) {
                    return view('projects.dashboard', compact(
                        'projects',
                        'project',
                        'profile',
                        'usersProjects',
                        'currentUserProjects',
                        'backlogItems',
                        'backlogItemTypeFeature',
                        'backlogItemTypeBug',
                        'backlogItemTypeEpic'
                    ));
                }
            }
        }

        abort(403);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Project $project
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $projects = Project::find($id)->count();

        return view('projects.index', compact('projects'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @param  \App\Project $project
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'title' => 'required|string',
            'deadline' => 'required|after_or_equal:now',
            'description' => 'required|string'
        ]);

        Project::find($id)->fill($request->input())->save();
        return redirect()->back()->with('updated', 'Project gegevens zijn bijgewerkt!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Project $project
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $project = Project::find($id);
        $project->delete();

        return redirect()->action('ProjectController@index');
    }
}

resources/views/projects/dashboard.blade.php
@extends('layouts.app')


@section('content')
    <div class="container" style="margin-left: 20%;">
        @foreach ($currentUserProjects as $currentUserProject)


            <div class="row">
                <div class="col-12" style="padding-top: 25px;">
                    <div style="box-shadow: 2px 2px 8px 2px lightgray; padding: 20px;">
                        <h2><i style="color: gray" class="fas fa-calendar-alt"></i> 	&nbsp; Nog {{$currentUserProject->deadlineForHumans}} Dagen tot de deadline
                            <a style="float: right" href="{{ route('project.edit', $currentUserProject->id) }}" class=""
                               data-toggle="modal" data-target="#wijzigen{{$currentUserProject->id }}">
                                <i style=" float:right; font-size: 40px" class="fas fa-edit big-edit-icon"></i>
                            </a>
                        </h2>
                    </div>
                </div>

                <div class="col-8" style="padding-top: 25px">
                    <div style="box-shadow: 2px 2px 8px 2px lightgray; padding: 30px;">
                        <h4>Backlogitems info</h4>
                        <hr>
                        <div class="row">
                            <div class="col-3 backlogitemCount">
                                <div class="rounded text-center" style="background: purple; padding: 10px">
                                    <i class="fas fas fa-clipboard-list" style="font-size: 30px"></i>
                                    <h2>{{$backlogItems->count()}}</h2>
                                    <p>Backlog items</p>
                                </div>
                            </div>

                            <div class="col-3 backlogitemCount">
                                <div class="rounded text-center" style="background: dodgerblue; padding: 10px">
                                    <i class="fas fas fa-clipboard-list" style="font-size: 30px"></i>
                                    <h2>{{$backlogItemTypeFeature->count()}}</h2>
                                    <p>Features</p>
                                </div>
                            </div>

                            <div class="col-3 backlogitemCount">
                                <div class="rounded text-center" style="background: red; padding: 10px">
                                    <i class="fas fa-bug" style="font-size: 30px"></i>
                                    <h2>{{$backlogItemTypeBug->count()}}</h2>
                                    <p>Bugs</p>
                                </div>
                            </div>

                            <div class="col-3 backlogitemCount">
                                <div class="rounded text-center" style="background: darkorange; padding: 10px">
                                    <i class="fas fas fa-crown" style="font-size: 30px"></i>
                                    <h2>{{$backlogItemTypeEpic->count()}}</h2>
                                    <p>Epic's</p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-4" style="padding-top: 25px">
                    <div style="box-shadow: 2px 2px 8px 2px lightgray; padding: 30px;">
                        <h4>Leden info</h4>
                        <hr>
                        @foreach ($usersProjects as $user)
                            <h5>
                                <img src="../../img/profile_picture.jpg" class="rounded-circle" alt="Profile picture"
                                     width="40px" height="40px" style="border: lightgray 2px solid">
                                {{ $user->name }}</h5>
                        @endforeach
                    </div>
                </div>
                <div class="modal fade" id="wijzigen{{$currentUserProject->id}}">
                    <div class="modal-dialog ">
                        <div class="modal-content">
                            <!-- Modal Header -->
                            <div class="modal-header">
                                <h4 class="modal-title">Wijzigen</h4>
                                <button type="button" class="close" data-dismiss="modal">&times;</button>
                            </div>
                            <!-- Modal body -->
                            <div class="modal-body">
                                <form style="padding-bottom: 50px"
                                      action="{{ route('project.update', $currentUserProject->id) }}" method="post">
                                    @csrf
                                    @method('PATCH')
                                    <div class="form-group">
                                        eind datum: <input type="date" class="form-control" name="deadline"
                                                           value="{{$currentUserProject->deadline}}" required>
                                        <label for="user-name" class="col-form-label">Naam:</label>
                                        <input type="text" name="title" value="{{ $currentUserProject->title }}"
                                               class="form-control" required>
                                        <label for="user-name" class="col-form-label">Beschrijving:</label>
                                        <textarea type="text" name="description" style="height: 150px;"
                                                  class="form-control"
                                                  required>{{ $currentUserProject->description }}</textarea>
                                    </div>
                                    <input type="submit" style="float: right" class="btn btn-success" value="aanpassen">
                                </form>
                                <a>Geadvanceerde instellingen</a>

                                <p style="margin-top: 5px">
                                    <button class="btn btn-danger" type="button" data-toggle="collapse"
                                            data-target="#collapseExample" aria-expanded="false"
                                            aria-controls="collapseExample">
                                        Verwijder dit project
                                    </button>
                                </p>
                                <div class="collapse" id="collapseExample">
                                    <div class="card card-body">
                                        Weet u zeker dat u het project {{$currentUserProject->title}} wilt verwijderen?
                                        <form action="{{ route('project.destroy' , $currentUserProject->id) }}"
                                              method="post">
                                            @csrf
                                            @method('DELETE')
                                            <div style="float: right;">
                                                <input type="submit" class="btn btn-danger" value="Ja">
                                                <button class="btn btn-success" type="button" data-toggle="collapse"
                                                        data-target="#collapseExample" aria-expanded="false"
                                                        aria-controls="collapseExample">
                                                    Nee
                                                </button>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>
                            <!-- Modal footer -->
                            <div class="modal-footer">
                                <button type="button" class="btn btn-danger" data-dismiss="modal">Sluiten</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
    </div>
    @endforeach
@endsection

resources/views/projects/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container" style="margin-left: 20%">
    @if (session('date'))
    <div class="mt-2 alert alert-success">
        {{ session('date') }}
    </div>
    @endif
    @if ($errors->any())
    <div class="mt-2 alert alert-danger">
        {{ $errors->first('deadline') }}
    </div>
    @endif
    <a href="#" data-toggle="model" data-target="addproject" style="padding-right: 25px">
        <i class="fas fa-filter"></i> Filter projecten
    </a>
    <a href="{{ route('project.store')}}" data-toggle="modal" data-target="#addproject">
        <i class="fas fa-plus-square"></i> Maak een project
    </a>
    <hr>
    @if($projects->projects->isEmpty())
    <div style="box-shadow: 2px 2px 8px 2px gray; padding: 50px; height: 210px">
        <h1>U heeft geen projecten</h1>
        <h4>Klik hier om een project aan te maken</h4>
        <img src="img/no_project.png" style="width: 150px; height: 150px; position: relative; left: 650px; bottom: 30px;">

        <button href="{{ route('project.store')}}" data-toggle="modal" data-target="#addproject" class="btn btn-success" style="float: right;"><i class="fas fa-chevron-right"></i>
        </button>
    </div>
    @endif

    <!-- The Modal -->
    <div class="modal fade" id="addproject">
        <div class="modal-dialog">
            <div class="modal-content">
                <form action="{{ route('project.store') }}" method="post">

                    <!-- Modal Header -->
                    <div class="modal-header">
                        <h4 class="modal-title">Voeg een project toe</h4>
                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <!-- Modal body -->
                    <div class="card">
                        @csrf
                        <div class="card-body">
                            Title: <input type="text" class="form-control" name="title" required>
                            Deadline: <input class="form-control" type="date" name="deadline" required>
                            Description: <input class="form-control" type="text" name="description" required><br>
                        </div>
                    </div>
                    <!-- Modal footer -->
                    <div class="modal-footer">
                        <input type="submit" class="btn btn-success" value="opslaan">
                        <button type="button" class="btn btn-danger" data-dismiss="modal">Sluiten</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
    <div class="container">
        <div class="row">
            @foreach($projects->projects as $project)
            <div class="col-md-6 col-sm-12 ">
                <a class="project-card-text" href="{{route('project.dashboard', $project->id)}}" method="post">
                    <div class="card mt-2 project-card">
                        <div class="card-header" style="padding-top: 5px; padding-bottom: 5px">
                            <div class="row" style="">
                                <div class="col-5">
                                    <div>
                                        <i class="fas fa-fingerprint" style="color: green"></i> {{ $project->title}}
                                    </div>
                                </div>
                                <div class="col-7" style=" @if($project->deadlineForHumans < 15) color: red; @endif">
                                    <div class="project-card-deadline">
                                        {{$project->deadlineForHumans }} Dagen tot de deadline

                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-6">
                                    {{$project->description}}
                                </div>
                                <div class="col-6">
                                    <div style="float: right">
                                        <h4 style="color: #00b0e8; padding-right: 20px">Leden:</h4>
                                        @foreach ($project->userProjects as $project->name)
                                        <p><i class="fas fa-user" style="color: #0E9A00;"></i>{{ $project->name->name }}</p>
                                        @endforeach
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </a>
            </div>
            @endforeach
        </div>
    </div>
</div>




@endsection